﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.Linq;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace pmt
{
    public partial class Form_rmAction : Form
    {
        private MainForm mainForm;

        public Form_rmAction()
        {
            InitializeComponent();
        }
        public Form_rmAction(MainForm mf)
        {
            InitializeComponent();
            mainForm = mf;
        }

        private void btn_rmAction_Save_Click(object sender, EventArgs e)
        {
            Program.ExitCode status;

            if (MessageBox.Show(this,
                            "Удалить Action?",
                            "Warning",
                            MessageBoxButtons.YesNo,
                            MessageBoxIcon.Warning) == DialogResult.No)
            {
                return;
            }

            //удалить Action после подтверждения:
            Action a = new Action
            {
                Name = cb_Name.Text,
            };

            status = RBACManager.RmAction(a, mainForm.db);

            if (status == Program.ExitCode.Success)
            {
                MessageBox.Show(this,
                            "Action удален!",
                            "Success",
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Information);
                this.Close();
                return;
            }
            if (status == Program.ExitCode.ElementDoesNotExists)
            {
                MessageBox.Show(this,
                            "The element doesn't exist!",
                            "Warning",
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Warning);
            }
            if (status == Program.ExitCode.Error)
            {
                MessageBox.Show(this,
                            "Error while submitting deletion to the DataBase",
                            "Error",
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Error);
                return;
            }
        }

        private void Form_rmAction_Load(object sender, EventArgs e)
        {
            // TODO: данная строка кода позволяет загрузить данные в таблицу "rbacDataSet.Action". При необходимости она может быть перемещена или удалена.
            this.actionTableAdapter.Fill(this.rbacDataSet.Action);
        }

        private void Form_rmAction_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape)
            {
                this.Close();
            }
        }

    }
}
